#define ID_MENU_FILE_OPEN  100
#define ID_MENU_FILE_SAVE  101
#define ID_MENU_FILE_CLEAR 102
#define ID_MENU_FILE_EXIT  103
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
class CMainWnd:public CWnd
{
 public:
  //-  --------------------------------------------------
  CMenu cMenu_Main;
  CMenu cMenu_File;
  //- ----------------------------------------------------------
  TCHAR FileName[16384];
  unsigned char Map[13][26];
  unsigned char VideoBuffer[416*208*3];
  unsigned char SpriteVideoBuffer[112*16*3];
  unsigned char SelectElement;
  CSprite cSprite;
  //-  ------------------------------------------------------
  CMainWnd(void);
  ~CMainWnd();
  //- --------------------------------------------------------
  DECLARE_MESSAGE_MAP()
  int OnCreate(LPCREATESTRUCT lpCreateStruct);
  int OnDestroy(void);
  void Menu_FileOpen(void);
  void Menu_FileSave(void);
  void Menu_FileClear(void);
  void Menu_FileExit(void);
  void OnPaint(void);
  void OnLButtonDown(UINT nFlags,CPoint point);
  void OnRButtonDown(UINT nFlags,CPoint point);
  void OnMouseMove(UINT nFlags,CPoint point);
  //- --------------------------------------------------------------
  void SetPoints(int bx,int by);
};
//------------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CMainWnd,CWnd)
 ON_WM_CREATE()
 ON_WM_DESTROY()
 ON_WM_PAINT()
 ON_WM_LBUTTONDOWN()
 ON_WM_RBUTTONDOWN()
 ON_WM_MOUSEMOVE()
 ON_COMMAND(ID_MENU_FILE_OPEN,Menu_FileOpen)
 ON_COMMAND(ID_MENU_FILE_SAVE,Menu_FileSave)
 ON_COMMAND(ID_MENU_FILE_CLEAR,Menu_FileClear)
 ON_COMMAND(ID_MENU_FILE_EXIT,Menu_FileExit)
END_MESSAGE_MAP()
//------------------------------------------------------------------------------
CMainWnd::CMainWnd(void)
{
}
CMainWnd::~CMainWnd()
{
}
//------------------------------------------------------------------------------
int CMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
 //-----------------------------------------------------------------------------
 // 
 //-----------------------------------------------------------------------------
 cMenu_File.CreatePopupMenu();
 cMenu_Main.CreateMenu();
 cMenu_File.InsertMenu(1,MF_STRING,ID_MENU_FILE_OPEN," ");
 cMenu_File.InsertMenu(2,MF_STRING,ID_MENU_FILE_SAVE," ");
 cMenu_File.InsertMenu(3,MF_SEPARATOR,0,"");
 cMenu_File.InsertMenu(4,MF_STRING,ID_MENU_FILE_CLEAR," ");
 cMenu_File.InsertMenu(5,MF_SEPARATOR,0,"");
 cMenu_File.InsertMenu(6,MF_STRING,ID_MENU_FILE_EXIT,"");
 cMenu_Main.InsertMenu(1,MF_POPUP,(UINT)cMenu_File.m_hMenu,"");
 SetMenu(&cMenu_Main);	
 DrawMenuBar();
 // 
 cSprite.Load("sprite.bmp");
 cSprite.SetSpriteSize(16,16);
 // 
 for(int x=0;x<26;x++)
  for(int y=0;y<13;y++) Map[y][x]=0;
 strcpy(FileName,"");
 SelectElement=0;
 return(0);
}
int CMainWnd::OnDestroy(void)
{
 return(0);
}
void CMainWnd::Menu_FileOpen(void)
{
 CFileDialog cFileDialog_Main(TRUE);
 TCHAR title[]=" ";
 CString str("*.txt");
 str+=(TCHAR)NULL;
 str+="*.txt";
 str+=(TCHAR)NULL;
 str+="*.*";
 str+=(TCHAR)NULL;
 str+="*.*";
 str+=(TCHAR)NULL;
 cFileDialog_Main.m_ofn.lpstrFilter=str;
 cFileDialog_Main.m_ofn.nFilterIndex=1;
 cFileDialog_Main.m_ofn.lpstrFile=FileName;
 cFileDialog_Main.m_ofn.lpstrTitle=title;
 int res=cFileDialog_Main.DoModal();
 if (res==IDOK)
 {
  FILE *file=fopen(cFileDialog_Main.m_ofn.lpstrFile,"r+b");
  if (file==NULL)
  {
   MessageBox("   ","",MB_OK);
   return;
  }
  int x,y;
  for(x=0;x<26;x++)
   for(y=0;y<13;y++) Map[y][x]=0;// 
  x=0;
  y=0;
  while(1)
  {
   unsigned char symbol;
   if(fread(&symbol,1,1,file)<=0) break;// 
   if (symbol==13)// 
   {
    x=0;
    y++;
    continue;
   }
   if (symbol<32) continue;// "" 
   if (symbol==32) symbol='-';
   if (x>=26) break;//   -   
   if (y>=13) break;//   -   
   Map[y][x]=0;
   if (symbol=='-') Map[y][x]=0;
   if (symbol=='.') Map[y][x]=1;
   if (symbol=='p' || symbol=='P') Map[y][x]=2;
   if (symbol=='c' || symbol=='C') Map[y][x]=3;
   if (symbol=='#') Map[y][x]=4;
   if (symbol=='!') Map[y][x]=5;
   if (symbol=='$') Map[y][x]=6;
   x++;
  }
  fclose(file);
  InvalidateRect(NULL,FALSE);
 }
}
void CMainWnd::Menu_FileSave(void)
{
 CFileDialog cFileDialog_Main(FALSE);
 TCHAR title[]=" ";
 CString str("*.txt");
 str+=(TCHAR)NULL;
 str+="*.txt";
 str+=(TCHAR)NULL;
 cFileDialog_Main.m_ofn.lpstrFilter=str;
 cFileDialog_Main.m_ofn.nFilterIndex=1;
 cFileDialog_Main.m_ofn.lpstrFile=FileName;
 cFileDialog_Main.m_ofn.lpstrTitle=title;
 cFileDialog_Main.m_ofn.lpstrDefExt="txt";
 int res=cFileDialog_Main.DoModal();
 if (res==IDOK)
 {
  FILE *file=fopen(cFileDialog_Main.m_ofn.lpstrFile,"w+b");
  if (file==NULL)
  {
   MessageBox("   ","",MB_OK);
   return;
  }
  for(int y=0;y<13;y++)
  {
   for(int x=0;x<26;x++) 
   {
    unsigned char code=Map[y][x];
    if (code==0) fprintf(file,"-");
    if (code==1) fprintf(file,".");
    if (code==2) fprintf(file,"P");
    if (code==3) fprintf(file,"C");
    if (code==4) fprintf(file,"#");
    if (code==5) fprintf(file,"!");
    if (code==6) fprintf(file,"$");
   }
   fprintf(file,"\r\n");
  }
  fclose(file);
 }
}
void CMainWnd::Menu_FileClear(void)
{
 int res=MessageBox(" ,      ?","",MB_YESNO|MB_DEFBUTTON2);
 if (res!=IDYES) return;
 for(int x=0;x<26;x++)
  for(int y=0;y<13;y++) Map[y][x]=0;
 InvalidateRect(NULL,FALSE);
}
void CMainWnd::Menu_FileExit(void)
{ 
 int res=MessageBox(" ,     ?","",MB_YESNO|MB_DEFBUTTON2);
 if (res!=IDYES) return;
 DestroyWindow();
}
void CMainWnd::OnPaint(void)
{
 int x,y;
 memset(VideoBuffer,0,416*208*3);
 //  
 for(x=0;x<26;x++)
 {
  unsigned char *vptr=VideoBuffer+x*3*16;
  for(y=0;y<208;y++,vptr+=416*3)
  {
   *(vptr)=255;
   *(vptr+1)=255;
   *(vptr+2)=255;
  }
 }
 for(y=0;y<13;y++)
 {
  unsigned char *vptr=VideoBuffer+y*3*16*416;
  for(x=0;x<416;x++,vptr+=3)
  {
   *(vptr)=255;
   *(vptr+1)=255;
   *(vptr+2)=255;
  }
 }
 //  
 cSprite.SetScreenSize(416,208);
 for(x=0;x<26;x++)
  for(y=0;y<13;y++)
  {
   if (Map[y][x]==0) continue;
   cSprite.SetSpriteCoord(Map[y][x],0);
   cSprite.Put(x*16,y*16,VideoBuffer);
  }
 CPaintDC dc(this);
 BITMAPINFOHEADER bmih;
 bmih.biSize=sizeof(BITMAPINFOHEADER);
 bmih.biWidth=416;
 bmih.biHeight=208;
 bmih.biPlanes=1;
 bmih.biBitCount=24;
 bmih.biCompression=BI_RGB;
 bmih.biSizeImage=0;
 bmih.biXPelsPerMeter=300;
 bmih.biYPelsPerMeter=300;
 bmih.biClrUsed=0;
 bmih.biClrImportant=0;
 RGBQUAD rgbq;
 BITMAPINFO info;
 rgbq.rgbBlue=1;
 rgbq.rgbGreen=0;
 rgbq.rgbRed=0;
 rgbq.rgbReserved=0;
 info.bmiHeader=bmih;
 info.bmiColors[0]=rgbq;
 StretchDIBits(dc.m_hDC,10,0,416,208,0,0,416,208,VideoBuffer,&info,DIB_RGB_COLORS,SRCCOPY);

 //  
 memset(SpriteVideoBuffer,112*16*3,0);
 cSprite.SetScreenSize(112,16);
 for(x=0;x<7;x++)
 {
  cSprite.SetSpriteCoord(x,0);
  if (x==SelectElement) cSprite.PutSelect(x*16,0,SpriteVideoBuffer);
                   else cSprite.Put(x*16,0,SpriteVideoBuffer);
 }

 bmih.biWidth=112;
 bmih.biHeight=16;
 info.bmiHeader=bmih;
 StretchDIBits(dc.m_hDC,10,210,112,16,0,0,112,16,SpriteVideoBuffer,&info,DIB_RGB_COLORS,SRCCOPY);
}
void CMainWnd::SetPoints(int bx,int by)
{
 if (bx<0 || bx>=26) return;
 if (by<0 || by>=13) return;
 if (Map[by][bx]!=0) return;
 Map[by][bx]=1;
 SetPoints(bx+1,by);
 SetPoints(bx-1,by);
 SetPoints(bx,by+1);
 SetPoints(bx,by-1);
}

void CMainWnd::OnLButtonDown(UINT nFlags,CPoint point)
{
 int m_x_1=point.x-10;
 int m_y_1=point.y;
 int m_x_2=point.x-10;
 int m_y_2=point.y-210;
 if (m_x_1>=0 && m_x_1<416 && m_y_1>=0 && m_y_1<208)
 {
  int bx=m_x_1/16;
  int by=m_y_1/16;
  //  
  if (SelectElement==1) SetPoints(bx,by);
  Map[by][bx]=SelectElement;  
  InvalidateRect(NULL,FALSE);
 }
 if (m_x_2>=0 && m_x_2<112 && m_y_2>=0 && m_y_2<16 && nFlags&MK_LBUTTON)
 {
  int bx=m_x_2/16;
  SelectElement=bx;
  InvalidateRect(NULL,FALSE);
 }
}
void CMainWnd::OnRButtonDown(UINT nFlags,CPoint point)
{
 int m_x_1=point.x-10;
 int m_y_1=point.y;
 if (m_x_1>=0 && m_x_1<416 && m_y_1>=0 && m_y_1<208)
 {
  int bx=m_x_1/16;
  int by=m_y_1/16;
  //  
  Map[by][bx]=0;
  InvalidateRect(NULL,FALSE);
 }
}

void CMainWnd::OnMouseMove(UINT nFlags,CPoint point)
{
 int m_x_1=point.x-10;
 int m_y_1=point.y;
 int m_x_2=point.x-10;
 int m_y_2=point.y-210;
 if (m_x_1>=0 && m_x_1<416 && m_y_1>=0 && m_y_1<208)
 {
  int bx=m_x_1/16;
  int by=m_y_1/16;
  //  
  if (nFlags&MK_LBUTTON) Map[by][bx]=SelectElement;
  if (nFlags&MK_RBUTTON) Map[by][bx]=0;
  InvalidateRect(NULL,FALSE);
 }
 if (m_x_2>=0 && m_x_2<112 && m_y_2>=0 && m_y_2<16 && nFlags&MK_LBUTTON)
 {
  if (nFlags&MK_LBUTTON)
  {
   int bx=m_x_2/16;
   SelectElement=bx;
   InvalidateRect(NULL,FALSE);
  }
 }
}
